# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [0.13.0] - 2024-04-26

- Add support for recursive liquid tags [#1731](https://github.com/Shopify/liquid/pull/1731)
- Match rounding precision to ruby gem when using the `round` filter with invalid precision.

## [0.12.0] - 2024-01-24

- Add support for inline comments

## [0.11.0] - 2023-12-20

- Remove dependency on Timex.
- Update other dependencies.

## [0.10.2] - 2023-09-19

- Add cache prefix for multitenancy [#44](https://github.com/handlecommerce/liquex/pull/44)
  - Thank you [dkulchenko](https://github.com/dkulchenko)
    Allow the cache to have a prefix to support multiple caches in case Liquex
    is used in a multitenant environment

## [0.10.1] - 2023-03-10

- Deprecated Liquex.render/2 for Liquex.render!/2
    Liquex.render/2 will be replaced with a function that returns an error tuple
    instead of raising an error in 0.11
- Add devcontainer
- Fix regression on round filter with invalid inputs

## [0.10.0] - 2022-12-19

- Add {% liquid %} tag to follow Liquid 5.0.0.

## [0.9.0] - 2022-09-14

- Add {% render %} tag to follow Liquid 5.0.0.
- Add caching behaviour for use in {% render %} tag.

## [0.8.0] - 2022-09-04

- Migrate all tags into using the new tag system originally defined by custom tag handler
- Add .last handler
- Fix issue where `break` and `continue` would throw away prior content in same scope
- Allow date filter to handle nil values [#34](https://github.com/markglenn/liquex/issues/34)
  - Thank you [stevencorona](https://github.com/stevencorona)
- Removed deprecated custom renderer code.

## [0.7.2] - 2022-04-19

- Fix struct access in liquid template regression [#31](https://github.com/markglenn/liquex/issues/31)

## [0.7.1] - 2022-03-31

- Allow accessing variables that implement the Access behaviour [#26](https://github.com/markglenn/liquex/pull/26)
- Allow types supporting String.Chars protocol to be used in string operations [#23](https://github.com/markglenn/liquex/pull/23)
  - Thank you [cipater](https://github.com/cipater)
- Allow multiple values in case statements [#29](https://github.com/markglenn/liquex/pull/29)
  - Thank you [ouven](https://github.com/ouven)

## [0.7.0] - 2021-09-17

- Refactored custom tags for better developer experience [#20](https://github.com/markglenn/liquex/issues/20)
  - Deprecated old custom tags format
- Added `Liquex.parse!/2` that raises an exception instead of returning an error tuple

## [0.6.3] - 2021-09-14

- Capture variables as strings instead of an iodata [#17](https://github.com/markglenn/liquex/pull/17)
  - Thank you [resterle](https://github.com/resterle)
- Optimize compilation speed [#19](https://github.com/markglenn/liquex/pull/19) [#18](https://github.com/markglenn/liquex/issues/18)
  - Thank you [tmjoen](https://github.com/tmjoen)

## [0.6.2] - 2021-09-12

- Fix object access using evaluated and literal args. [#15](https://github.com/markglenn/liquex/pull/15)
  - Thank you [ouven](https://github.com/ouven)

## [0.6.1] - 2021-06-30

- Fix `contains` to_existing_atom call. [#12](https://github.com/markglenn/liquex/issues/12)

## [0.6.0] - 2021-04-11

This release is now 100% compatible with the
[Liquid](https://github.com/Shopify/liquid) gem for ruby.

### Added

- Whitespace control using `{%-` and `{{-`

## [0.5.0] - 2020-10-22

### Added

- Indifferent access in structs/maps using string or atom keys

## [0.4.2] - 2020-09-26

### Added

- Sort and where clauses to Liquex.Collection

### Fixed

- Fixed issue where identifiers could not end in question marks

## [0.4.1] - 2020-09-05

### Added

- `{% assign %}` now allows the use of filters

## [0.4.0] - 2020-08-16

### Added

- `Liquex.Collection` added for for custom iterators
- `Liquex.Represent` added for lazy object rendering
